<?php
/**
 * CustomersSettingsData
 *
 * @package  BigCommerce\Api\v3
 */

/**
 * BigCommerce API
 *
 * A Swagger Document for the BigCommmerce v3 API.
 *
 * OpenAPI spec version: 3.0.0b
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace BigCommerce\Api\v3\Model;

use \ArrayAccess;

class CustomersSettingsData implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'CustomersSettings_data';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'privacy_settings' => '\BigCommerce\Api\v3\Model\CustomersSettingsDataPrivacySettings',
        'customer_group_settings' => '\BigCommerce\Api\v3\Model\CustomersSettingsDataCustomerGroupSettings',
        'allow_global_logins' => 'bool'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'privacy_settings' => 'privacy_settings',
        'customer_group_settings' => 'customer_group_settings',
        'allow_global_logins' => 'allow_global_logins'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'privacy_settings' => 'setPrivacySettings',
        'customer_group_settings' => 'setCustomerGroupSettings',
        'allow_global_logins' => 'setAllowGlobalLogins'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'privacy_settings' => 'getPrivacySettings',
        'customer_group_settings' => 'getCustomerGroupSettings',
        'allow_global_logins' => 'getAllowGlobalLogins'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = [])
    {
        $this->container['privacy_settings'] = array_key_exists('privacy_settings', $data) ? $data['privacy_settings'] : null;
        $this->container['customer_group_settings'] = array_key_exists('customer_group_settings', $data) ? $data['customer_group_settings'] : null;
        $this->container['allow_global_logins'] = array_key_exists('allow_global_logins', $data) ? $data['allow_global_logins'] : null;
    }

    /**
     * returns container
     * @return array
     */
    public function get()
    {
        return $this->container;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets privacy_settings
     * @return \BigCommerce\Api\v3\Model\CustomersSettingsDataPrivacySettings
     */
    public function getPrivacySettings()
    {
        return $this->container['privacy_settings'];
    }

    /**
     * Sets privacy_settings
     * @param \BigCommerce\Api\v3\Model\CustomersSettingsDataPrivacySettings $privacy_settings
     * @return $this
     */
    public function setPrivacySettings($privacy_settings)
    {
        $this->container['privacy_settings'] = $privacy_settings;

        return $this;
    }

    /**
     * Gets customer_group_settings
     * @return \BigCommerce\Api\v3\Model\CustomersSettingsDataCustomerGroupSettings
     */
    public function getCustomerGroupSettings()
    {
        return $this->container['customer_group_settings'];
    }

    /**
     * Sets customer_group_settings
     * @param \BigCommerce\Api\v3\Model\CustomersSettingsDataCustomerGroupSettings $customer_group_settings
     * @return $this
     */
    public function setCustomerGroupSettings($customer_group_settings)
    {
        $this->container['customer_group_settings'] = $customer_group_settings;

        return $this;
    }

    /**
     * Gets allow_global_logins
     * @return bool
     */
    public function getAllowGlobalLogins()
    {
        return $this->container['allow_global_logins'];
    }

    /**
     * Sets allow_global_logins
     * @param bool $allow_global_logins
     * @return $this
     */
    public function setAllowGlobalLogins($allow_global_logins)
    {
        $this->container['allow_global_logins'] = $allow_global_logins;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\BigCommerce\Api\v3\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\BigCommerce\Api\v3\ObjectSerializer::sanitizeForSerialization($this));
    }
}


